Arvados - Bug #15685

File rename doesn't work, succeeds when no name is provided

10/03/2019 07:42 PM - Eric Biagiotti

Status: Resolved Start date: 10/22/2020
Priority: Normal Due date:

Assigned To: Lucas Di Pentima % Done: 100%
Category: Workbench2 Estimated time: 0.00 hour
Target version: 2020-11-18

Description

Renaming a file in a collection with a blank value reports a successful rename to the user even though file doesn't get renamed.

Subtasks:
Task # 16966: Review 15685-file-renaming-empty-name

Resolved

Related issues:
Related to Arvados - Bug #16592: File renaming doesn't work

Resolved 09/23/2020

Associated revisions

Revision a0d117b3 - 11/12/2020 07:32 PM - Lucas Di Pentima

Merge branch '15685-file-renaming-empty-name'
Closes #15685

Arvados-DCO-1.1-Signed-off-by: Lucas Di Pentima <lucas@di-pentima.com.ar>

History

#1 - 02/12/2020 03:19 PM - Peter Amstutz

- Release set to 20

#2 - 06/29/2020 08:44 PM - Peter Amstutz

- Release changed from 20 to 31

#3 - 06/29/2020 08:45 PM - Peter Amstutz

- Subject changed from File rename succeeds when no name is provided to File rename doesn't work, succeeds when no name is provided

#4 - 10/07/2020 03:47 PM - Peter Amstutz
- Target version set to 2020-10-21 Sprint
- Assigned To set to Daniel Kutyta

#5 - 10/21/2020 03:55 PM - Peter Amstutz
- Target version changed from 2020-10-21 Sprint to 2020-11-04 Sprint

#6 - 10/21/2020 04:07 PM - Peter Amstutz

- Assigned To changed from Daniel Kutyta to Lucas Di Pentima

#7 - 10/22/2020 03:26 PM - Lucas Di Pentima

- Status changed from New to In Progress

#8 - 10/22/2020 11:41 PM - Lucas Di Pentima

Updates at arvados-workbench?2|3af60f74 - branch 15685-file-renaming-empty-name
Test run: https://ci.arvados.org/view/Developer/job/developer-tests-workbench2/136/

® File renaming was fixed in #16592.
* Fixes webdav service's backend error response handling.
e Adds integration tests for file renaming cases.

#9 - 10/22/2020 11:44 PM - Lucas Di Pentima

12/08/2021

1/3



mailto:lucas@di-pentima.com.ar
https://dev.arvados.org/projects/arvados/repository/arvados-workbench2/revisions/3af60f74e1bb43c779d660bda187d780b677188e
https://ci.arvados.org/view/Developer/job/developer-tests-workbench2/136/
https://dev.arvados.org/issues/16592

- Related to Bug #16592: File renaming doesn't work added

#10 - 11/04/2020 04:37 PM - Lucas Di Pentima
- Target version changed from 2020-11-04 Sprint to 2020-11-18

#11 - 11/05/2020 10:18 PM - Peter Amstutz
15685-file-renaming-empty-name @ commit:arvados-workflow2|3af60f74e1bb43c779d660bda187d780b677188e
| found a couple of edge cases:

e | can enter a name of "&" which gets turned into "&amp;"
® | can enter a name of " "

After renaming a file from a valid name either of the invalid names, | can't rename or delete the file:
Rename gets "Could not rename the file: Forbidden"

Delete gets "Could not remove file."

It needs to correctly handle or prevent these edge cases.

#12 - 11/05/2020 10:45 PM - Peter Amstutz

A couple other illegal names to check for are "." and ".."

#13 - 11/10/2020 04:09 PM - Lucas Di Pentima

Updates at arvados-workbench?2|6528692d
Test run: https://ci.arvados.org/view/Developer/job/developer-tests-workbench2/168/

The edge cases were caused by missing file name decoding or encoding while working with the webdav service:

A file named '&' was displayed as '&amp;' because that's how it receives the data from keep-web, so | added a html decoding call.
When trying to rename the '&' the MOVE request were directed to '&amp;' instead.

A file name can legally be ' ' (whitespace) as per the Ruby SDK (see sdk/ruby/test/test_keep_manifest.rb starting at L307.
Expanded file renaming integeration tests.

An interesting side effect of using webdav to rename files is that we can rename a file to something like 'subdir/a_file' and it'll be moved to the 'subdir/'
directory. | haven't written test cases for this yet, just in case it isn't a desirable behavior, and if that's the case, we should add validations on the
rename form to avoid having /' chars on the names (right now the validations are done on the backend, and | think that's a good thing, to avoid having
duplicated code).

#14 - 11/10/2020 06:50 PM - Peter Amstutz
From chat:
1. WB2 rename should allow editing the entire file path within the collection. This enables the user to move files into other directories of the
collection.

2. WB2 should not accept names with leading or trailing spaces (even though they are technically allowable on the backend).
1. This should probably include a validation that splits on '/' and makes sure the path parts don't have leading or trailing spaces either.

#15 - 11/12/2020 12:46 AM - Lucas Di Pentima

Updates at arvados-workbench2|1b9616cd
Test run: https://ci.arvados.org/view/Developer/job/developer-tests-workbench2/174/

e WB2 now shows the entire file path on the "rename file" dialog.
¢ Added validations so that every path part cannot have leading/trailing whitespaces or be an empty string.
¢ Added more integration tests checking these new behaviors.

#16 - 11/12/2020 01:26 PM - Lucas Di Pentima

Test re-run: https://ci.arvados.org/view/Developer/job/developer-tests-workbench2/175/

#17 - 11/12/2020 05:17 PM - Peter Amstutz
15685-file-renaming-empty-name @ arvados-workbench2|1b9616cd4d120cdc473e457637287502fff531b8

Renaming works much better now, thank you! | can even rename invalid files with invalid names getting an error or strange behavior. Moving files
into and out of subdirectories seems to work fine.

Moving files be
| found two user interaction bugs.

1.1f 1 open "Rename" and then enter an invalid name, | don't see an error until the text box loses focus. The "Ok" button remains disabled, but |
have no feedback about what is wrong with the name until | try to click outside the text box (hitting enter doesn't do it). After the error appears
once, then it appears/disappears immediately based on whether the contents of the text box is valid like | would expect to happen.

2. The invalid file names "." and ".." are not flagged as errors, it allows you to hit "Ok" but then you get the non-specific error "Could not rename the
file: Precondition Failed". Related, | can also include "." and ".." when renaming files, which seems to be interpreted as Unix path, which
suggests you might be able to enter a filename like "../../c=collection_uuid/newfile" and it would move the file to another collection (if keep-web

supports that.)

#18 - 11/12/2020 07:18 PM - Lucas Di Pentima

Updates at arvados-workbench2|4745e251
Test run: https://ci.arvados.org/view/Developer/job/developer-tests-workbench2/176/

e Fixed both issues. The "validation on blur" was just a redux-form config setting.
e Ajusted integration tests a bit.

#19 - 11/12/2020 07:23 PM - Peter Amstutz
Lucas Di Pentima wrote:

Updates at arvados-workbench2|4745e251
Test run: https://ci.arvados.org/view/Developer/job/developer-tests-workbench2/176/

e Fixed both issues. The "validation on blur" was just a redux-form config setting.
o Ajusted integration tests a bit.

Thanks, this LGTM!

#20 - 11/13/2020 01:03 AM - Anonymous

- Status changed from In Progress to Resolved

Applied in changeset arvados-workbench?2|a0d117b3fae1311a6eb98612946be8966bdf2cf5.

#21 - 11/16/2020 10:11 PM - Peter Amstutz
- Release changed from 31 to 36

12/08/2021 3/3


https://dev.arvados.org/projects/arvados/repository/arvados-workbench2/revisions/4745e25131346a4521884773be1ce11a349c3263
https://ci.arvados.org/view/Developer/job/developer-tests-workbench2/176/
https://dev.arvados.org/projects/arvados/repository/arvados-workbench2/revisions/4745e25131346a4521884773be1ce11a349c3263
https://ci.arvados.org/view/Developer/job/developer-tests-workbench2/176/
https://dev.arvados.org/projects/arvados/repository/arvados-workbench2/revisions/a0d117b3fae1311a6eb98612946be8966bdf2cf5
http://www.tcpdf.org

